| Flutter Linux Embedder |

Typedefs | Enumerations | Functions
fl_engine_private.h File Reference
`#include <glib-object.h>`
`#include "flutter/shell/platform/embedder/embedder.h"`
`#include "flutter/shell/platform/linux/fl_renderer.h"`
`#include "flutter/shell/platform/linux/fl_task_runner.h"`
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_dart_project.h"`
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_engine.h"`

Go to the source code of this file.

## Typedefs
typedef gboolean(* | FlEnginePlatformMessageHandler) (FlEngine *engine, const gchar *channel, GBytes *message, const FlutterPlatformMessageResponseHandle *response_handle, gpointer user_data)
typedef void(* | FlEngineUpdateSemanticsNodeHandler) (FlEngine *engine, const FlutterSemanticsNode *node, gpointer user_data)
typedef void(* | FlEngineOnPreEngineRestartHandler) (FlEngine *engine, gpointer user_data)

## Enumerations
enum | FlEngineError { FL_ENGINE_ERROR_FAILED }

## Functions
GQuark | fl_engine_error_quark (void) G_GNUC_CONST
FlEngine * | fl_engine_new (FlDartProject *project, FlRenderer *renderer)
FlutterEngineProcTable * | fl_engine_get_embedder_api (FlEngine *engine)
void | fl_engine_set_platform_message_handler (FlEngine *engine, FlEnginePlatformMessageHandler handler, gpointer user_data, GDestroyNotify destroy_notify)
void | fl_engine_set_update_semantics_node_handler (FlEngine *engine, FlEngineUpdateSemanticsNodeHandler handler, gpointer user_data, GDestroyNotify destroy_notify)
void | fl_engine_set_on_pre_engine_restart_handler (FlEngine *engine, FlEngineOnPreEngineRestartHandler handler, gpointer user_data, GDestroyNotify destroy_notify)
gboolean | fl_engine_start (FlEngine *engine, GError **error)
void | fl_engine_send_window_metrics_event (FlEngine *engine, size_t width, size_t height, double pixel_ratio)
void | fl_engine_send_window_state_event (FlEngine *engine, gboolean visible, gboolean focused)
void | fl_engine_send_mouse_pointer_event (FlEngine *engine, FlutterPointerPhase phase, size_t timestamp, double x, double y, double scroll_delta_x, double scroll_delta_y, int64_t buttons)
void | fl_engine_send_pointer_pan_zoom_event (FlEngine *self, size_t timestamp, double x, double y, FlutterPointerPhase phase, double pan_x, double pan_y, double scale, double rotation)
void | fl_engine_send_key_event (FlEngine *engine, const FlutterKeyEvent *event, FlutterKeyEventCallback callback, void *user_data)
void | fl_engine_dispatch_semantics_action (FlEngine *engine, uint64_t id, FlutterSemanticsAction action, GBytes *data)
gboolean | fl_engine_send_platform_message_response (FlEngine *engine, const FlutterPlatformMessageResponseHandle *handle, GBytes *response, GError **error)
void | fl_engine_send_platform_message (FlEngine *engine, const gchar *channel, GBytes *message, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer user_data)
GBytes * | fl_engine_send_platform_message_finish (FlEngine *engine, GAsyncResult *result, GError **error)
FlTaskRunner * | fl_engine_get_task_runner (FlEngine *engine)
void | fl_engine_execute_task (FlEngine *engine, FlutterTask *task)
gboolean | fl_engine_mark_texture_frame_available (FlEngine *engine, int64_t texture_id)
gboolean | fl_engine_register_external_texture (FlEngine *engine, int64_t texture_id)
gboolean | fl_engine_unregister_external_texture (FlEngine *engine, int64_t texture_id)
void | fl_engine_update_accessibility_features (FlEngine *engine, int32_t flags)
GPtrArray * | fl_engine_get_switches (FlEngine *engine)

## Typedef Documentation

## ◆ FlEngineOnPreEngineRestartHandler

typedef void(* FlEngineOnPreEngineRestartHandler) (FlEngine *engine, gpointer user_data)

FlEngineOnPreEngineRestartHandler: @engine: an #FlEngine. @user_data: (closure): data provided when registering this handler.

Function called right before the engine is restarted.

Definition at line 70 of file fl_engine_private.h.

## ◆ FlEnginePlatformMessageHandler

typedef gboolean(* FlEnginePlatformMessageHandler) (FlEngine *engine, const gchar *channel, GBytes *message, const FlutterPlatformMessageResponseHandle *response_handle, gpointer user_data)

FlEnginePlatformMessageHandler: @engine: an #FlEngine. @channel: channel message received on. @message: message content received from Dart. @response_handle: a handle to respond to the message with. @user_data: (closure): data provided when registering this handler.

Function called when platform messages are received.

Returns: TRUE if message has been accepted.

Definition at line 43 of file fl_engine_private.h.

## ◆ FlEngineUpdateSemanticsNodeHandler

typedef void(* FlEngineUpdateSemanticsNodeHandler) (FlEngine *engine, const FlutterSemanticsNode *node, gpointer user_data)

FlEngineUpdateSemanticsNodeHandler: @engine: an #FlEngine. @node: semantic node information. @user_data: (closure): data provided when registering this handler.

Function called when semantics node updates are received.

Definition at line 58 of file fl_engine_private.h.

## Enumeration Type Documentation

## ◆ FlEngineError

enum FlEngineError

FlEngineError: Errors for #FlEngine objects to set on failures.

Enumerator
FL_ENGINE_ERROR_FAILED |

Definition at line 23 of file fl_engine_private.h.

23 {
24 // NOLINTBEGIN(readability-identifier-naming)
25 FL_ENGINE_ERROR_FAILED,
26 // NOLINTEND(readability-identifier-naming)
27 } FlEngineError;

## Function Documentation

## ◆ fl_engine_dispatch_semantics_action()

void fl_engine_dispatch_semantics_action | ( | FlEngine * | engine,
|  | uint64_t | id,
|  | FlutterSemanticsAction | action,
|  | GBytes * | data
| ) |  |

fl_engine_dispatch_semantics_action: @engine: an #FlEngine. @id: the semantics action identifier. @action: the action being dispatched. @data: (allow-none): data associated with the action.

Definition at line 860 of file fl_engine.cc.

863 {
864 g_return_if_fail(FL_IS_ENGINE(self));
865
866 if (self->engine == nullptr) {
867 return;
868 }
869
870 const uint8_t* action_data = nullptr;
871 size_t action_data_length = 0;
872 if (data != nullptr) {
873 action_data = static_cast<const uint8_t*>(
874 g_bytes_get_data(data, &action_data_length));
875 }
876
877 self->embedder_api.DispatchSemanticsAction(self->engine, id, action,
878 action_data, action_data_length);
879 }

References self.

Referenced by fl_accessible_node_perform_action_impl(), and TEST().

## ◆ fl_engine_error_quark()

GQuark fl_engine_error_quark | ( | void |  | ) |

Referenced by fl_engine_send_platform_message(), fl_engine_send_platform_message_response(), and fl_engine_start().

## ◆ fl_engine_execute_task()

void fl_engine_execute_task | ( | FlEngine * | engine,
|  | FlutterTask * | task
| ) |  |

fl_engine_execute_task: @engine: an #FlEngine. @task: a #FlutterTask to execute.

Executes given Flutter task.

Definition at line 913 of file fl_engine.cc.

913 {
914 g_return_if_fail(FL_IS_ENGINE(self));
915 self->embedder_api.RunTask(self->engine, task);
916 }

References self.

Referenced by fl_task_runner_process_expired_tasks_locked().

## ◆ fl_engine_get_embedder_api()

FlutterEngineProcTable* fl_engine_get_embedder_api | ( | FlEngine * | engine | ) |

fl_engine_get_embedder_api: @engine: an #FlEngine.

Gets the embedder API proc table, allowing modificiations for unit testing.

Returns: a mutable pointer to the embedder API proc table.

Definition at line 591 of file fl_engine.cc.

591 {
592 return &(self->embedder_api);
593 }

Referenced by TEST().

## ◆ fl_engine_get_switches()

GPtrArray* fl_engine_get_switches | ( | FlEngine * | engine | ) |

fl_engine_get_switches: @project: an #FlEngine.

Determines the switches that should be passed to the Flutter engine.

Returns: an array of switches to pass to the Flutter engine.

Definition at line 935 of file fl_engine.cc.

935 {
936 GPtrArray* switches = g_ptr_array_new_with_free_func(g_free);
937 for (const auto& env_switch : flutter::GetSwitchesFromEnvironment()) {
938 g_ptr_array_add(switches, g_strdup(env_switch.c_str()));
939 }
940 return switches;
941 }

References flutter::GetSwitchesFromEnvironment().

Referenced by fl_engine_start(), and TEST().

## ◆ fl_engine_get_task_runner()

FlTaskRunner* fl_engine_get_task_runner | ( | FlEngine * | engine | ) |

fl_engine_get_task_runner: @engine: an #FlEngine.

Returns
  : a #FlTaskRunner.

Returns: task runner responsible for scheduling Flutter tasks.

Definition at line 908 of file fl_engine.cc.

908 {
909 g_return_val_if_fail(FL_IS_ENGINE(self), nullptr);
910 return self->task_runner;
911 }

Referenced by fl_renderer_unblock_main_thread(), and fl_renderer_wait_for_frame().

## ◆ fl_engine_mark_texture_frame_available()

gboolean fl_engine_mark_texture_frame_available | ( | FlEngine * | engine,
|  | int64_t | texture_id
| ) |  |

fl_engine_mark_texture_frame_available: @engine: an #FlEngine. @texture_id: the identifier of the texture whose frame has been updated.

Tells the Flutter engine that a new texture frame is available for the given texture.

Returns: TRUE on success.

Definition at line 881 of file fl_engine.cc.

882 {
883 g_return_val_if_fail(FL_IS_ENGINE(self), FALSE);
884 return self->embedder_api.MarkExternalTextureFrameAvailable(
885 self->engine, texture_id) == kSuccess;
886 }

References self, and texture_id.

Referenced by mark_texture_frame_available().

## ◆ fl_engine_new()

FlEngine* fl_engine_new | ( | FlDartProject * | project,
|  | FlRenderer * | renderer
| ) |  |

fl_engine_new: @project: an #FlDartProject. @renderer: an #FlRenderer.

Creates new Flutter engine.

Returns: a new #FlEngine.

Definition at line 467 of file fl_engine.cc.

467 {
468 g_return_val_if_fail(FL_IS_DART_PROJECT(project), nullptr);
469 g_return_val_if_fail(FL_IS_RENDERER(renderer), nullptr);
470
471 FlEngine* self = FL_ENGINE(g_object_new(fl_engine_get_type(), nullptr));
472 self->project = FL_DART_PROJECT(g_object_ref(project));
473 self->renderer = FL_RENDERER(g_object_ref(renderer));
474 self->binary_messenger = fl_binary_messenger_new(self);
475 return self;
476 }

References fl_binary_messenger_new().

Referenced by fl_engine_new_headless(), fl_view_constructed(), and make_mock_engine().

## ◆ fl_engine_register_external_texture()

gboolean fl_engine_register_external_texture | ( | FlEngine * | engine,
|  | int64_t | texture_id
| ) |  |

fl_engine_register_external_texture: @engine: an #FlEngine. @texture_id: the identifier of the texture that is available.

Tells the Flutter engine that a new external texture is available.

Returns: TRUE on success.

Definition at line 888 of file fl_engine.cc.

889 {
890 g_return_val_if_fail(FL_IS_ENGINE(self), FALSE);
891 return self->embedder_api.RegisterExternalTexture(self->engine, texture_id) ==
892 kSuccess;
893 }

References self, and texture_id.

Referenced by register_texture().

## ◆ fl_engine_send_key_event()

void fl_engine_send_key_event | ( | FlEngine * | engine,
|  | const FlutterKeyEvent * | event,
|  | FlutterKeyEventCallback | callback,
|  | void * | user_data
| ) |  |

fl_engine_send_key_event:

Definition at line 847 of file fl_engine.cc.

850 {
851 g_return_if_fail(FL_IS_ENGINE(self));
852
853 if (self->engine == nullptr) {
854 return;
855 }
856
857 self->embedder_api.SendKeyEvent(self->engine, event, callback, user_data);
858 }

References callback, event, self, and user_data.

Referenced by fl_view_keyboard_delegate_iface_init().

## ◆ fl_engine_send_mouse_pointer_event()

void fl_engine_send_mouse_pointer_event | ( | FlEngine * | engine,
|  | FlutterPointerPhase | phase,
|  | size_t | timestamp,
|  | double | x,
|  | double | y,
|  | double | scroll_delta_x,
|  | double | scroll_delta_y,
|  | int64_t | buttons
| ) |  |

fl_engine_send_mouse_pointer_event: @engine: an #FlEngine. @phase: mouse phase. @timestamp: time when event occurred in microseconds. @x: x location of mouse cursor. @y: y location of mouse cursor. @scroll_delta_x: x offset of scroll. @scroll_delta_y: y offset of scroll. @buttons: buttons that are pressed.

Sends a mouse pointer event to the engine.

Definition at line 778 of file fl_engine.cc.

785 {
786 g_return_if_fail(FL_IS_ENGINE(self));
787
788 if (self->engine == nullptr) {
789 return;
790 }
791
792 FlutterPointerEvent fl_event = {};
793 fl_event.struct_size = sizeof(fl_event);
794 fl_event.phase = phase;
795 fl_event.timestamp = timestamp;
796 fl_event.x = x;
797 fl_event.y = y;
798 if (scroll_delta_x != 0 || scroll_delta_y != 0) {
799 fl_event.signal_kind = kFlutterPointerSignalKindScroll;
800 }
801 fl_event.scroll_delta_x = scroll_delta_x;
802 fl_event.scroll_delta_y = scroll_delta_y;
803 fl_event.device_kind = kFlutterPointerDeviceKindMouse;
804 fl_event.buttons = buttons;
805 fl_event.device = kMousePointerDeviceId;
806 // TODO(dkwingsmt): Assign the correct view ID once the Linux embedder
807 // supports multiple views.
808 // https://github.com/flutter/flutter/issues/138178
809 fl_event.view_id = flutter::kFlutterImplicitViewId;
810 self->embedder_api.SendPointerEvent(self->engine, &fl_event, 1);
811 }

References kMousePointerDeviceId, and self.

Referenced by check_pointer_inside(), fl_view_scrolling_delegate_iface_init(), leave_notify_event_cb(), motion_notify_event_cb(), send_pointer_button_event(), and TEST().

## ◆ fl_engine_send_platform_message()

void fl_engine_send_platform_message | ( | FlEngine * | engine,
|  | const gchar * | channel,
|  | GBytes * | message,
|  | GCancellable * | cancellable,
|  | GAsyncReadyCallback | callback,
|  | gpointer | user_data
| ) |  |

fl_engine_send_platform_message: @engine: an #FlEngine. @channel: channel to send to. @message: (allow-none): message buffer to send or NULL for an empty message @cancellable: (allow-none): a #GCancellable or NULL. @callback: (scope async): a #GAsyncReadyCallback to call when the request is satisfied. @user_data: (closure): user data to pass to @callback.

Asynchronously sends a platform message.

Definition at line 680 of file fl_engine.cc.

685 {
686 g_return_if_fail(FL_IS_ENGINE(self));
687
688 GTask* task = nullptr;
689 FlutterPlatformMessageResponseHandle* response_handle = nullptr;
690 if (callback != nullptr) {
691 task = g_task_new(self, cancellable, callback, user_data);
692
693 if (self->engine == nullptr) {
694 g_task_return_new_error(task, fl_engine_error_quark(),
695 FL_ENGINE_ERROR_FAILED, "No engine to send to");
696 return;
697 }
698
699 FlutterEngineResult result =
700 self->embedder_api.PlatformMessageCreateResponseHandle(
701 self->engine, fl_engine_platform_message_response_cb, task,
702 &response_handle);
703 if (result != kSuccess) {
704 g_task_return_new_error(task, fl_engine_error_quark(),
705 FL_ENGINE_ERROR_FAILED,
706 "Failed to create response handle");
707 g_object_unref(task);
708 return;
709 }
710 } else if (self->engine == nullptr) {
711 return;
712 }
713
714 FlutterPlatformMessage fl_message = {};
715 fl_message.struct_size = sizeof(fl_message);
716 fl_message.channel = channel;
717 fl_message.message =
718 message != nullptr
719 ? static_cast<const uint8_t*>(g_bytes_get_data(message, nullptr))
720 : nullptr;
721 fl_message.message_size = message != nullptr ? g_bytes_get_size(message) : 0;
722 fl_message.response_handle = response_handle;
723 FlutterEngineResult result =
724 self->embedder_api.SendPlatformMessage(self->engine, &fl_message);
725
726 if (result != kSuccess && task != nullptr) {
727 g_task_return_new_error(task, fl_engine_error_quark(),
728 FL_ENGINE_ERROR_FAILED,
729 "Failed to send platform messages");
730 g_object_unref(task);
731 }
732
733 if (response_handle != nullptr) {
734 self->embedder_api.PlatformMessageReleaseResponseHandle(self->engine,
735 response_handle);
736 }
737 }

References callback, FL_ENGINE_ERROR_FAILED, fl_engine_error_quark(), fl_engine_platform_message_response_cb(), result, self, and user_data.

Referenced by send_on_channel(), and TEST().

## ◆ fl_engine_send_platform_message_finish()

GBytes* fl_engine_send_platform_message_finish | ( | FlEngine * | engine,
|  | GAsyncResult * | result,
|  | GError ** | error
| ) |  |

fl_engine_send_platform_message_finish: @engine: an #FlEngine.

Returns
  : a #GAsyncResult. @error: (allow-none): #GError location to store the error occurring, or NULL to ignore.

Completes request started with fl_engine_send_platform_message().

Returns: message response on success or NULL on error.

Definition at line 739 of file fl_engine.cc.

741 {
742 g_return_val_if_fail(FL_IS_ENGINE(self), FALSE);
743 g_return_val_if_fail(g_task_is_valid(result, self), FALSE);
744
745 return static_cast<GBytes*>(g_task_propagate_pointer(G_TASK(result), error));
746 }

References error, and result.

Referenced by send_on_channel_finish().

## ◆ fl_engine_send_platform_message_response()

gboolean fl_engine_send_platform_message_response | ( | FlEngine * | engine,
|  | const FlutterPlatformMessageResponseHandle * | handle,
|  | GBytes * | response,
|  | GError ** | error
| ) |  |

fl_engine_send_platform_message_response: @engine: an #FlEngine. @handle: handle that was provided in FlEnginePlatformMessageHandler. @response: (allow-none): response to send or NULL for an empty response. @error: (allow-none): #GError location to store the error occurring, or NULL to ignore.

Responds to a platform message.

Returns: TRUE on success.

Definition at line 648 of file fl_engine.cc.

652 {
653 g_return_val_if_fail(FL_IS_ENGINE(self), FALSE);
654 g_return_val_if_fail(handle != nullptr, FALSE);
655
656 if (self->engine == nullptr) {
657 g_set_error(error, fl_engine_error_quark(), FL_ENGINE_ERROR_FAILED,
658 "No engine to send response to");
659 return FALSE;
660 }
661
662 gsize data_length = 0;
663 const uint8_t* data = nullptr;
664 if (response != nullptr) {
665 data =
666 static_cast<const uint8_t*>(g_bytes_get_data(response, &data_length));
667 }
668 FlutterEngineResult result = self->embedder_api.SendPlatformMessageResponse(
669 self->engine, handle, data, data_length);
670
671 if (result != kSuccess) {
672 g_set_error(error, fl_engine_error_quark(), FL_ENGINE_ERROR_FAILED,
673 "Failed to send platform message response");
674 return FALSE;
675 }
676
677 return TRUE;
678 }

References error, FL_ENGINE_ERROR_FAILED, fl_engine_error_quark(), result, self, and TRUE.

Referenced by fl_engine_platform_message_cb(), send_response(), and TEST().

## ◆ fl_engine_send_pointer_pan_zoom_event()

void fl_engine_send_pointer_pan_zoom_event | ( | FlEngine * | self,
|  | size_t | timestamp,
|  | double | x,
|  | double | y,
|  | FlutterPointerPhase | phase,
|  | double | pan_x,
|  | double | pan_y,
|  | double | scale,
|  | double | rotation
| ) |  |

Definition at line 813 of file fl_engine.cc.

821 {
822 g_return_if_fail(FL_IS_ENGINE(self));
823
824 if (self->engine == nullptr) {
825 return;
826 }
827
828 FlutterPointerEvent fl_event = {};
829 fl_event.struct_size = sizeof(fl_event);
830 fl_event.timestamp = timestamp;
831 fl_event.x = x;
832 fl_event.y = y;
833 fl_event.phase = phase;
834 fl_event.pan_x = pan_x;
835 fl_event.pan_y = pan_y;
836 fl_event.scale = scale;
837 fl_event.rotation = rotation;
838 fl_event.device = kPointerPanZoomDeviceId;
839 fl_event.device_kind = kFlutterPointerDeviceKindTrackpad;
840 // TODO(dkwingsmt): Assign the correct view ID once the Linux embedder
841 // supports multiple views.
842 // https://github.com/flutter/flutter/issues/138178
843 fl_event.view_id = flutter::kFlutterImplicitViewId;
844 self->embedder_api.SendPointerEvent(self->engine, &fl_event, 1);
845 }

References kPointerPanZoomDeviceId, and self.

Referenced by fl_view_scrolling_delegate_iface_init(), and TEST().

## ◆ fl_engine_send_window_metrics_event()

void fl_engine_send_window_metrics_event | ( | FlEngine * | engine,
|  | size_t | width,
|  | size_t | height,
|  | double | pixel_ratio
| ) |  |

fl_engine_send_window_metrics_event: @engine: an #FlEngine. @width: width of the window in pixels. @height: height of the window in pixels. @pixel_ratio: scale factor for window.

Sends a window metrics event to the engine.

Definition at line 760 of file fl_engine.cc.

763 {
764 g_return_if_fail(FL_IS_ENGINE(self));
765
766 if (self->engine == nullptr) {
767 return;
768 }
769
770 FlutterWindowMetricsEvent event = {};
771 event.struct_size = sizeof(FlutterWindowMetricsEvent);
772 event.width = width;
773 event.height = height;
774 event.pixel_ratio = pixel_ratio;
775 self->embedder_api.SendWindowMetricsEvent(self->engine, &event);
776 }

References event, height, self, and width.

Referenced by handle_geometry_changed(), and TEST().

## ◆ fl_engine_send_window_state_event()

void fl_engine_send_window_state_event | ( | FlEngine * | engine,
|  | gboolean | visible,
|  | gboolean | focused
| ) |  |

fl_engine_send_window_state_event: @engine: an #FlEngine. @visible: whether the window is currently visible or not. @focused: whether the window is currently focused or not.

Sends a window state event to the engine.

Definition at line 748 of file fl_engine.cc.

750 {
751 if (visible && focused) {
752 set_app_lifecycle_state(self, flutter::AppLifecycleState::kResumed);
753 } else if (visible) {
754 set_app_lifecycle_state(self, flutter::AppLifecycleState::kInactive);
755 } else {
756 set_app_lifecycle_state(self, flutter::AppLifecycleState::kHidden);
757 }
758 }

References flutter::kHidden, flutter::kInactive, flutter::kResumed, and set_app_lifecycle_state().

Referenced by TEST(), and window_state_event_cb().

## ◆ fl_engine_set_on_pre_engine_restart_handler()

void fl_engine_set_on_pre_engine_restart_handler | ( | FlEngine * | engine,
|  | FlEngineOnPreEngineRestartHandler | handler,
|  | gpointer | user_data,
|  | GDestroyNotify | destroy_notify
| ) |  |

fl_engine_set_on_pre_engine_restart_handler: @engine: an #FlEngine. @handler: function to call when the engine is restarted. @user_data: (closure): user data to pass to @handler. @destroy_notify: (allow-none): a function which gets called to free @user_data, or NULL.

Registers the function called right before the engine is restarted.

Definition at line 630 of file fl_engine.cc.

634 {
635 g_return_if_fail(FL_IS_ENGINE(self));
636
637 if (self->on_pre_engine_restart_handler_destroy_notify) {
638 self->on_pre_engine_restart_handler_destroy_notify(
639 self->on_pre_engine_restart_handler_data);
640 }
641
642 self->on_pre_engine_restart_handler = handler;
643 self->on_pre_engine_restart_handler_data = user_data;
644 self->on_pre_engine_restart_handler_destroy_notify = destroy_notify;
645 }

References self, and user_data.

Referenced by fl_view_constructed(), fl_view_dispose(), and TEST().

## ◆ fl_engine_set_platform_message_handler()

void fl_engine_set_platform_message_handler | ( | FlEngine * | engine,
|  | FlEnginePlatformMessageHandler | handler,
|  | gpointer | user_data,
|  | GDestroyNotify | destroy_notify
| ) |  |

fl_engine_set_platform_message_handler: @engine: an #FlEngine. @handler: function to call when a platform message is received. @user_data: (closure): user data to pass to @handler. @destroy_notify: (allow-none): a function which gets called to free @user_data, or NULL.

Registers the function called when a platform message is received. Call fl_engine_send_platform_message_response() with the response to this message. Ownership of #FlutterPlatformMessageResponseHandle is transferred to the caller, and the message must be responded to avoid memory leaks.

Definition at line 595 of file fl_engine.cc.

599 {
600 g_return_if_fail(FL_IS_ENGINE(self));
601 g_return_if_fail(handler != nullptr);
602
603 if (self->platform_message_handler_destroy_notify) {
604 self->platform_message_handler_destroy_notify(
605 self->platform_message_handler_data);
606 }
607
608 self->platform_message_handler = handler;
609 self->platform_message_handler_data = user_data;
610 self->platform_message_handler_destroy_notify = destroy_notify;
611 }

References self, and user_data.

Referenced by fl_binary_messenger_new().

## ◆ fl_engine_set_update_semantics_node_handler()

void fl_engine_set_update_semantics_node_handler | ( | FlEngine * | engine,
|  | FlEngineUpdateSemanticsNodeHandler | handler,
|  | gpointer | user_data,
|  | GDestroyNotify | destroy_notify
| ) |  |

fl_engine_set_update_semantics_node_handler: @engine: an #FlEngine. @handler: function to call when a semantics node update is received. @user_data: (closure): user data to pass to @handler. @destroy_notify: (allow-none): a function which gets called to free @user_data, or NULL.

Registers the function called when a semantics node update is reveived.

Definition at line 613 of file fl_engine.cc.

617 {
618 g_return_if_fail(FL_IS_ENGINE(self));
619
620 if (self->update_semantics_node_handler_destroy_notify) {
621 self->update_semantics_node_handler_destroy_notify(
622 self->update_semantics_node_handler_data);
623 }
624
625 self->update_semantics_node_handler = handler;
626 self->update_semantics_node_handler_data = user_data;
627 self->update_semantics_node_handler_destroy_notify = destroy_notify;
628 }

References self, and user_data.

Referenced by fl_view_constructed(), and fl_view_dispose().

## ◆ fl_engine_start()

gboolean fl_engine_start | ( | FlEngine * | engine,
|  | GError ** | error
| ) |  |

fl_engine_start: @engine: an #FlEngine. @error: (allow-none): #GError location to store the error occurring, or NULL to ignore.

Starts the Flutter engine.

Returns: TRUE on success.

Definition at line 483 of file fl_engine.cc.

483 {
484 g_return_val_if_fail(FL_IS_ENGINE(self), FALSE);
485
486 self->task_runner = fl_task_runner_new(self);
487
488 FlutterRendererConfig config = {};
489 config.type = kOpenGL;
490 config.open_gl.struct_size = sizeof(FlutterOpenGLRendererConfig);
491 config.open_gl.gl_proc_resolver = fl_engine_gl_proc_resolver;
492 config.open_gl.make_current = fl_engine_gl_make_current;
493 config.open_gl.clear_current = fl_engine_gl_clear_current;
494 config.open_gl.fbo_callback = fl_engine_gl_get_fbo;
495 config.open_gl.present = fl_engine_gl_present;
496 config.open_gl.make_resource_current = fl_engine_gl_make_resource_current;
497 config.open_gl.gl_external_texture_frame_callback =
498 fl_engine_gl_external_texture_frame_callback;
499
500 FlutterTaskRunnerDescription platform_task_runner = {};
501 platform_task_runner.struct_size = sizeof(FlutterTaskRunnerDescription);
502 platform_task_runner.user_data = self;
503 platform_task_runner.runs_task_on_current_thread_callback =
504 fl_engine_runs_task_on_current_thread;
505 platform_task_runner.post_task_callback = fl_engine_post_task;
506 platform_task_runner.identifier = kPlatformTaskRunnerIdentifier;
507
508 FlutterCustomTaskRunners custom_task_runners = {};
509 custom_task_runners.struct_size = sizeof(FlutterCustomTaskRunners);
510 custom_task_runners.platform_task_runner = &platform_task_runner;
511 custom_task_runners.render_task_runner = &platform_task_runner;
512
513 g_autoptr(GPtrArray) command_line_args = fl_engine_get_switches(self);
514 // FlutterProjectArgs expects a full argv, so when processing it for flags
515 // the first item is treated as the executable and ignored. Add a dummy value
516 // so that all switches are used.
517 g_ptr_array_insert(command_line_args, 0, g_strdup("flutter"));
518
519 gchar** dart_entrypoint_args =
520 fl_dart_project_get_dart_entrypoint_arguments(self->project);
521
522 FlutterProjectArgs args = {};
523 args.struct_size = sizeof(FlutterProjectArgs);
524 args.assets_path = fl_dart_project_get_assets_path(self->project);
525 args.icu_data_path = fl_dart_project_get_icu_data_path(self->project);
526 args.command_line_argc = command_line_args->len;
527 args.command_line_argv =
528 reinterpret_cast<const char* const*>(command_line_args->pdata);
529 args.platform_message_callback = fl_engine_platform_message_cb;
530 args.update_semantics_node_callback = fl_engine_update_semantics_node_cb;
531 args.custom_task_runners = &custom_task_runners;
532 args.shutdown_dart_vm_when_done = true;
533 args.on_pre_engine_restart_callback = fl_engine_on_pre_engine_restart_cb;
534 args.dart_entrypoint_argc =
535 dart_entrypoint_args != nullptr ? g_strv_length(dart_entrypoint_args) : 0;
536 args.dart_entrypoint_argv =
537 reinterpret_cast<const char* const*>(dart_entrypoint_args);
538
539 FlutterCompositor compositor = {};
540 compositor.struct_size = sizeof(FlutterCompositor);
541 compositor.user_data = self->renderer;
542 compositor.create_backing_store_callback =
543 compositor_create_backing_store_callback;
544 compositor.collect_backing_store_callback =
545 compositor_collect_backing_store_callback;
546 compositor.present_layers_callback = compositor_present_layers_callback;
547 args.compositor = &compositor;
548
549 if (self->embedder_api.RunsAOTCompiledDartCode()) {
550 FlutterEngineAOTDataSource source = {};
551 source.type = kFlutterEngineAOTDataSourceTypeElfPath;
552 source.elf_path = fl_dart_project_get_aot_library_path(self->project);
553 if (self->embedder_api.CreateAOTData(&source, &self->aot_data) !=
554 kSuccess) {
555 g_set_error(error, fl_engine_error_quark(), FL_ENGINE_ERROR_FAILED,
556 "Failed to create AOT data");
557 return FALSE;
558 }
559 args.aot_data = self->aot_data;
560 }
561
562 FlutterEngineResult result = self->embedder_api.Initialize(
563 FLUTTER_ENGINE_VERSION, &config, &args, self, &self->engine);
564 if (result != kSuccess) {
565 g_set_error(error, fl_engine_error_quark(), FL_ENGINE_ERROR_FAILED,
566 "Failed to initialize Flutter engine");
567 return FALSE;
568 }
569
570 result = self->embedder_api.RunInitialized(self->engine);
571 if (result != kSuccess) {
572 g_set_error(error, fl_engine_error_quark(), FL_ENGINE_ERROR_FAILED,
573 "Failed to run Flutter engine");
574 return FALSE;
575 }
576
577 setup_locales(self);
578
579 g_autoptr(FlSettings) settings = fl_settings_new();
580 self->settings_plugin = fl_settings_plugin_new(self);
581 fl_settings_plugin_start(self->settings_plugin, settings);
582
583 result = self->embedder_api.UpdateSemanticsEnabled(self->engine, TRUE);
584 if (result != kSuccess) {
585 g_warning("Failed to enable accessibility features on Flutter engine");
586 }
587
588 return TRUE;
589 }

References args, compositor_collect_backing_store_callback(), compositor_create_backing_store_callback(), compositor_present_layers_callback(), error, fl_dart_project_get_aot_library_path(), fl_dart_project_get_assets_path(), fl_dart_project_get_dart_entrypoint_arguments(), fl_dart_project_get_icu_data_path(), FL_ENGINE_ERROR_FAILED, fl_engine_error_quark(), fl_engine_get_switches(), fl_engine_gl_clear_current(), fl_engine_gl_external_texture_frame_callback(), fl_engine_gl_get_fbo(), fl_engine_gl_make_current(), fl_engine_gl_make_resource_current(), fl_engine_gl_present(), fl_engine_gl_proc_resolver(), fl_engine_on_pre_engine_restart_cb(), fl_engine_platform_message_cb(), fl_engine_post_task(), fl_engine_runs_task_on_current_thread(), fl_engine_update_semantics_node_cb(), fl_settings_new(), fl_settings_plugin_new(), fl_settings_plugin_start(), fl_task_runner_new(), kPlatformTaskRunnerIdentifier, result, self, setup_locales(), and TRUE.

Referenced by make_mock_engine(), realize_cb(), and TEST().

## ◆ fl_engine_unregister_external_texture()

gboolean fl_engine_unregister_external_texture | ( | FlEngine * | engine,
|  | int64_t | texture_id
| ) |  |

fl_engine_unregister_external_texture: @engine: an #FlEngine. @texture_id: the identifier of the texture that is not available anymore.

Tells the Flutter engine that an existing external texture is not available anymore.

Returns: TRUE on success.

Definition at line 895 of file fl_engine.cc.

896 {
897 g_return_val_if_fail(FL_IS_ENGINE(self), FALSE);
898 return self->embedder_api.UnregisterExternalTexture(self->engine,
899 texture_id) == kSuccess;
900 }

References self, and texture_id.

Referenced by unregister_texture().

## ◆ fl_engine_update_accessibility_features()

void fl_engine_update_accessibility_features | ( | FlEngine * | engine,
|  | int32_t | flags
| ) |  |

fl_engine_update_accessibility_features: @engine: an #FlEngine. @flags: the features to enable in the accessibility tree.

Tells the Flutter engine to update the flags on the accessibility tree.

Definition at line 924 of file fl_engine.cc.

924 {
925 g_return_if_fail(FL_IS_ENGINE(self));
926
927 if (self->engine == nullptr) {
928 return;
929 }
930
931 self->embedder_api.UpdateAccessibilityFeatures(
932 self->engine, static_cast<FlutterAccessibilityFeature>(flags));
933 }

References flags, and self.

Referenced by update_settings().

fl_dart_project_get_aot_library_path
const G_MODULE_EXPORT gchar * fl_dart_project_get_aot_library_path(FlDartProject *self)
Definition: fl_dart_project.cc:72
event
FlKeyEvent * event
Definition: fl_key_channel_responder.cc:118
flutter::AppLifecycleState::kHidden
@ kHidden
fl_engine_update_semantics_node_cb
static void fl_engine_update_semantics_node_cb(const FlutterSemanticsNode *node, void *user_data)
Definition: fl_engine.cc:336
fl_engine_platform_message_response_cb
static void fl_engine_platform_message_response_cb(const uint8_t *data, size_t data_length, void *user_data)
Definition: fl_engine.cc:362
fl_engine_gl_get_fbo
static uint32_t fl_engine_gl_get_fbo(void *user_data)
Definition: fl_engine.cc:238
fl_engine_gl_make_resource_current
static bool fl_engine_gl_make_resource_current(void *user_data)
Definition: fl_engine.cc:249
FL_ENGINE_ERROR_FAILED
@ FL_ENGINE_ERROR_FAILED
Definition: fl_engine_private.h:25
kMousePointerDeviceId
static constexpr int32_t kMousePointerDeviceId
Definition: fl_engine.cc:35
set_app_lifecycle_state
static void set_app_lifecycle_state(FlEngine *self, const flutter::AppLifecycleState state)
Definition: fl_engine.cc:130
compositor_collect_backing_store_callback
static bool compositor_collect_backing_store_callback(const FlutterBackingStore *renderer, void *user_data)
Definition: fl_engine.cc:195
fl_settings_new
FlSettings * fl_settings_new()
Definition: fl_settings.cc:55
fl_engine_gl_present
static bool fl_engine_gl_present(void *user_data)
Definition: fl_engine.cc:243
flags
FlutterSemanticsFlag flags
Definition: fl_accessible_node.cc:105
user_data
FlKeyEvent uint64_t FlKeyResponderAsyncCallback gpointer user_data
Definition: fl_key_channel_responder.cc:121
fl_engine_on_pre_engine_restart_cb
static void fl_engine_on_pre_engine_restart_cb(void *user_data)
Definition: fl_engine.cc:351
fl_dart_project_get_assets_path
const G_MODULE_EXPORT gchar * fl_dart_project_get_assets_path(FlDartProject *self)
Definition: fl_dart_project.cc:85
height
G_BEGIN_DECLS int height
Definition: fl_backing_store_provider.h:37
fl_binary_messenger_new
FlBinaryMessenger * fl_binary_messenger_new(FlEngine *engine)
Definition: fl_binary_messenger.cc:406
fl_settings_plugin_start
void fl_settings_plugin_start(FlSettingsPlugin *self, FlSettings *settings)
Definition: fl_settings_plugin.cc:112
kPlatformTaskRunnerIdentifier
static constexpr size_t kPlatformTaskRunnerIdentifier
Definition: fl_engine.cc:31
flutter::AppLifecycleState::kInactive
@ kInactive
compositor_present_layers_callback
static bool compositor_present_layers_callback(const FlutterLayer **layers, size_t layers_count, void *user_data)
Definition: fl_engine.cc:203
fl_engine_gl_external_texture_frame_callback
static bool fl_engine_gl_external_texture_frame_callback(void *user_data, int64_t texture_id, size_t width, size_t height, FlutterOpenGLTexture *opengl_texture)
Definition: fl_engine.cc:260
TRUE
return TRUE
Definition: fl_pixel_buffer_texture_test.cc:53
flutter::GetSwitchesFromEnvironment
std::vector< std::string > GetSwitchesFromEnvironment()
Definition: engine_switches.cc:14
fl_dart_project_get_dart_entrypoint_arguments
G_MODULE_EXPORT gchar ** fl_dart_project_get_dart_entrypoint_arguments(FlDartProject *self)
Definition: fl_dart_project.cc:104
fl_engine_runs_task_on_current_thread
static bool fl_engine_runs_task_on_current_thread(void *user_data)
Definition: fl_engine.cc:301
self
GdkEvent FlView * self
Definition: fl_view.cc:100
result
GAsyncResult * result
Definition: fl_text_input_plugin.cc:106
FlEngineError
FlEngineError
Definition: fl_engine_private.h:23
args
G_BEGIN_DECLS G_MODULE_EXPORT FlValue * args
Definition: fl_event_channel.h:89
error
const uint8_t uint32_t uint32_t GError ** error
Definition: fl_pixel_buffer_texture_test.cc:40
flutter::AppLifecycleState::kResumed
@ kResumed
fl_engine_gl_proc_resolver
static void * fl_engine_gl_proc_resolver(void *user_data, const char *name)
Definition: fl_engine.cc:213
setup_locales
static void setup_locales(FlEngine *self)
Definition: fl_engine.cc:150
compositor_create_backing_store_callback
static bool compositor_create_backing_store_callback(const FlutterBackingStoreConfig *config, FlutterBackingStore *backing_store_out, void *user_data)
Definition: fl_engine.cc:185
callback
FlKeyEvent uint64_t FlKeyResponderAsyncCallback callback
Definition: fl_key_channel_responder.cc:120
fl_engine_error_quark
GQuark fl_engine_error_quark(void) G_GNUC_CONST
fl_dart_project_get_icu_data_path
const G_MODULE_EXPORT gchar * fl_dart_project_get_icu_data_path(FlDartProject *self)
Definition: fl_dart_project.cc:98
texture_id
int64_t texture_id
Definition: texture_registrar_unittests.cc:24
width
const uint8_t uint32_t * width
Definition: fl_pixel_buffer_texture_test.cc:38
fl_engine_gl_make_current
static bool fl_engine_gl_make_current(void *user_data)
Definition: fl_engine.cc:218
fl_engine_get_switches
GPtrArray * fl_engine_get_switches(FlEngine *self)
Definition: fl_engine.cc:935
fl_engine_post_task
static void fl_engine_post_task(FlutterTask task, uint64_t target_time_nanos, void *user_data)
Definition: fl_engine.cc:307
fl_task_runner_new
FlTaskRunner * fl_task_runner_new(FlEngine *engine)
Definition: fl_task_runner.cc:161
fl_settings_plugin_new
FlSettingsPlugin * fl_settings_plugin_new(FlEngine *engine)
Definition: fl_settings_plugin.cc:94
fl_engine_platform_message_cb
static void fl_engine_platform_message_cb(const FlutterPlatformMessage *message, void *user_data)
Definition: fl_engine.cc:316
kPointerPanZoomDeviceId
static constexpr int32_t kPointerPanZoomDeviceId
Definition: fl_engine.cc:36
fl_engine_gl_clear_current
static bool fl_engine_gl_clear_current(void *user_data)
Definition: fl_engine.cc:228